"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("./request/index");
var config_1 = require("./request/config");
var Config = (function () {
    function Config() {
    }
    Object.defineProperty(Config.prototype, "defaultConfig", {
        get: function () {
            return DefaultConfig;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Config.prototype, "config", {
        get: function () {
            return this._config || (this._config = this.buildConfig());
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Config.prototype, "use", {
        get: function () {
            return this._use;
        },
        set: function (use) {
            this._use = use;
            this._config = this.buildConfig(use);
        },
        enumerable: true,
        configurable: true
    });
    Config.prototype.reset = function () {
        this._config = this.defaultConfig;
        this._use = null;
    };
    Config.prototype.buildConfig = function (conf) {
        if (conf === void 0) { conf = {}; }
        var c = __assign({}, this.defaultConfig, conf);
        if (conf.request) {
            c.request = __assign({}, this.defaultConfig.request, conf.request);
        }
        if (conf.sites) {
            c.sites = __assign({}, this.defaultConfig.sites, conf.sites);
        }
        return c;
    };
    return Config;
}());
exports.Config = Config;
exports.ginConfig = new Config();
exports.retryStrategy = new index_1.RequestRetryStrategy();
exports.cloudflareStrategy = new index_1.RequestCloudFlareStrategy();
var DefaultConfig = __assign({ pooling: {
        MangafoxSearch: {
            requestInterval: 5000,
            match: /mangafox\.me\/search\.php/
        },
        // NOTE this should be always the last one!
        "*": {
            simultaneousRequests: 30,
            maxQueueSize: 300,
            safeQueueSize: 50,
            match: /.*/,
        }
    }, disableHttps: true, sites: {
        batoto: exports.cloudflareStrategy,
        mangafox: exports.retryStrategy,
        mangapanda: exports.retryStrategy,
        MangaHere: exports.retryStrategy,
        kissmanga: exports.cloudflareStrategy,
    } }, config_1.reqConfig);
exports.default = exports.ginConfig;
