"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var config_1 = require("./../config");
var util_1 = require("./../util");
var Queue = require("promise-queue");
var TICK = 33;
var pools;
function request(uri, strategy) {
    var pool;
    if (!config_1.ginConfig.config.pooling || !(pool = getPool(uri))) {
        return strategy.request(uri);
    }
    return pool.queue.queue(uri, strategy);
}
exports.request = request;
function getPool(uri) {
    pools = pools || buildPool();
    var url = isOptionsWithUrl(uri)
        ? uri.url.toString()
        : uri;
    return pools.find(function (x) { return !!url.match(x.match); });
}
exports.getPool = getPool;
function isOptionsWithUrl(uri) {
    return uri.url !== undefined;
}
function rebuildPool() {
    pools = buildPool();
}
exports.rebuildPool = rebuildPool;
function buildPool() {
    var pooling = config_1.ginConfig.config.pooling;
    var pools = [];
    for (var p in pooling) {
        var pool = pooling[p];
        var queue = void 0;
        if (pool.requestInterval) {
            queue = new IntervalPool(pool);
        }
        else {
            if (pool.simultaneousRequests) {
                queue = new ConcurrentQueue(pool);
            }
            else {
                throw new Error("unknown pool type");
            }
        }
        pools.push(__assign({}, pool, { queue: queue }));
    }
    return pools;
}
//
// export class IntervalPool implements QueuePool {
//   private _currId: number = 0;
//
//   private _active: ActivePool;
//   // private _history: {[id: string]: HistoryPool} = {};
//   private _history = new Map<number, HistoryPool>();
//
//   get history(): HistoryPool[] {
//     return Array.from(this._history.values());
//   } // copy list
//
//
//   get isActive(): boolean {
//     return !!this._active;
//   }
//
//
//   private set active(value: ActivePool) {
//     // const h = this._history[this._active.id];
//     // h.resolved = true;
//     this._active = value;
//   }
//
//
//   constructor(private _config: GinPoolConfig) {
//   }
//
//
//   queue(uri: GinUrlOptions, strategy: RequestStrategy): Promise<any> {
//     let id = this.getNextId();
//     const last = this._history.get(id - 1);
//     const history: HistoryPool = {
//       id,
//       uri,
//       isActive: true,
//       created: new Date(),
//     };
//     this._history.set(id, history);
//
//     let lazy = new Lazy(async () => {
//       try {
//         history.started = new Date();
//         return await strategy.request(uri);
//       }
//       finally {
//         history.resolved = new Date();
//       }
//     });
//
//     if (last) {
//       lazy = history.item = this.waitForLast(last, lazy);
//     }
//
//     return this.execItem(id, lazy);
//   }
//
//   private async execItem(id: number, lazy: Lazy<Promise<any>>) {
//     const h = this._history.get(id);
//
//     try {
//       this.active = {
//         id,
//         uri: h.uri,
//         isActive: true,
//       };
//       h.item = lazy;
//       return await lazy.value.catch(x => {
//         throw h.error = x;
//       });
//     }
//     finally {
//       h.failed = true;
//       h.isActive = false;
//       this.active = null;
//     }
//   }
//
//   private waitForLast(last: HistoryPool, lazy: Lazy<Promise<any>>): Lazy<Promise<any>> {
//     const {requestInterval} = this._config;
//     return new Lazy(async () => {
//       while (last.isActive) {
//         await last.item.value // just wait until the last finish or fails, if it fails we should ignore the exception
//           .catch((e) => e);
//       }
//       const dt = last.resolved;
//       const passedTime = Date.now() - dt.getTime();
//
//       const missing = requestInterval - passedTime;
//
//       if (missing > 0) {
//         await promiseSetTimeout(missing);
//       }
//       return await lazy.value;
//     });
//   }
//
//   private getNextId() {
//     return this._currId++;
//   }
// }
var ConcurrentQueue = (function () {
    function ConcurrentQueue(_config) {
        this._config = _config;
        this._currId = 0;
        this._history = new Map();
        this._queue = new Queue(_config.simultaneousRequests);
    }
    Object.defineProperty(ConcurrentQueue.prototype, "history", {
        get: function () {
            return Array.from(this._history.values());
        } // copy list
        ,
        enumerable: true,
        configurable: true
    });
    ConcurrentQueue.prototype.queue = function (uri, strategy) {
        return __awaiter(this, void 0, void 0, function () {
            var lazy;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(this._queue.getQueueLength() > this._config.maxQueueSize)) return [3 /*break*/, 3];
                        _a.label = 1;
                    case 1:
                        if (!(this._queue.getQueueLength() < this._config.safeQueueSize)) return [3 /*break*/, 3];
                        return [4 /*yield*/, util_1.promiseSetTimeout(TICK)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 1];
                    case 3:
                        lazy = new util_1.Lazy(function () { return strategy.request(uri); });
                        return [2 /*return*/, this._queue.add(function () { return lazy.value; })];
                }
            });
        });
    };
    // async exec(lazy: Lazy<Promise<any>>, history: HistoryPool) {
    //   try {
    //     history.item = lazy;
    //     return await lazy.value.catch(x => {
    //       throw history.error = x;
    //     });
    //   }
    //   finally {
    //     history.failed = true;
    //     history.isActive = false;
    //   }
    // }
    ConcurrentQueue.prototype.getNextId = function () {
        return this._currId++;
    };
    return ConcurrentQueue;
}());
exports.ConcurrentQueue = ConcurrentQueue;
var IntervalLazy = (function (_super) {
    __extends(IntervalLazy, _super);
    // appendNew(func : ()=>T){
    //   return new IntervalLazy(async ()=>{
    //
    //     while(thi)
    //     if(!this.started){
    //
    //     }
    //
    //
    //
    //
    //
    //   });
    // }
    function IntervalLazy(_func, _requestInterval) {
        var _this = _super.call(this, function () {
            _this.started = new Date();
            try {
                var result = _func();
                if (result instanceof Promise) {
                    result.then(function (x) {
                        _this.resolved = new Date();
                        return x;
                    }).catch(function (x) {
                        _this.resolved = new Date();
                        _this.error = x;
                        _this.failed = true;
                    });
                }
                else {
                    _this.resolved = new Date();
                }
                return result;
            }
            catch (e) {
                _this.resolved = new Date();
                _this.error = e;
                _this.failed = true;
            }
        }) || this;
        _this._requestInterval = _requestInterval;
        _this.created = new Date();
        return _this;
    }
    IntervalLazy.prototype.append = function (lazy) {
        return __awaiter(this, void 0, void 0, function () {
            var pValue, w_1, w;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        pValue = null;
                        _a.label = 1;
                    case 1:
                        if (!!this.resolved) return [3 /*break*/, 6];
                        w_1 = (this.created.getMilliseconds() + this._requestInterval) - Date.now();
                        if (!(w_1 > 0)) return [3 /*break*/, 3];
                        return [4 /*yield*/, util_1.promiseSetTimeout(w_1)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 3:
                        pValue = this.value;
                        return [4 /*yield*/, pValue];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [3 /*break*/, 1];
                    case 6:
                        w = (this.resolved.getMilliseconds() + this._requestInterval) - Date.now();
                        if (!(w > 0)) return [3 /*break*/, 8];
                        return [4 /*yield*/, util_1.promiseSetTimeout(w)];
                    case 7:
                        _a.sent();
                        _a.label = 8;
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    return IntervalLazy;
}(util_1.Lazy));
exports.IntervalLazy = IntervalLazy;
var IntervalPool = (function () {
    // history: HistoryPool[]; //TODO remove
    function IntervalPool(_config) {
        this._config = _config;
    }
    IntervalPool.prototype.queue = function (uri, strategy) {
        return __awaiter(this, void 0, void 0, function () {
            var prev, current, w, p, e_1, w2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        prev = this.currentLazy;
                        current = new IntervalLazy(function () { return strategy.request(uri); }, this._config.requestInterval);
                        this.currentLazy = current;
                        if (!prev) return [3 /*break*/, 10];
                        w = (prev.created.getTime() + this._config.requestInterval) - Date.now();
                        if (!(w > 0)) return [3 /*break*/, 2];
                        return [4 /*yield*/, util_1.promiseSetTimeout(w)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        if (!!prev.started) return [3 /*break*/, 4];
                        return [4 /*yield*/, util_1.promiseSetTimeout(TICK)];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 2];
                    case 4:
                        p = prev.value;
                        _a.label = 5;
                    case 5:
                        _a.trys.push([5, 7, , 8]);
                        return [4 /*yield*/, p];
                    case 6:
                        _a.sent();
                        return [3 /*break*/, 8];
                    case 7:
                        e_1 = _a.sent();
                        return [3 /*break*/, 8];
                    case 8:
                        w2 = (prev.resolved.getTime() + this._config.requestInterval) - Date.now();
                        if (!(w2 > 0)) return [3 /*break*/, 10];
                        return [4 /*yield*/, util_1.promiseSetTimeout(w2)];
                    case 9:
                        _a.sent();
                        _a.label = 10;
                    case 10: return [4 /*yield*/, current.value];
                    case 11: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    return IntervalPool;
}());
exports.IntervalPool = IntervalPool;
