"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var url_1 = require("url");
var config_1 = require("./config");
var lodash_1 = require("lodash");
var enum_1 = require("../../enum");
var util_1 = require("../../util");
var Supported = {};
Supported[enum_1.Genre.Action] = enum_1.Genre.Action;
Supported[enum_1.Genre.Adult] = enum_1.Genre.Adult;
Supported[enum_1.Genre.Adventure] = enum_1.Genre.Adventure;
Supported[enum_1.Genre.Comedy] = enum_1.Genre.Comedy;
Supported[enum_1.Genre.Doujinshi] = enum_1.Genre.Doujinshi;
Supported[enum_1.Genre.Drama] = enum_1.Genre.Drama;
Supported[enum_1.Genre.Ecchi] = enum_1.Genre.Ecchi;
Supported[enum_1.Genre.Fantasy] = enum_1.Genre.Fantasy;
Supported[enum_1.Genre.GenderBender] = enum_1.Genre.GenderBender;
Supported[enum_1.Genre.Harem] = enum_1.Genre.Harem;
Supported[enum_1.Genre.Historical] = enum_1.Genre.Historical;
Supported[enum_1.Genre.Horror] = enum_1.Genre.Horror;
Supported[enum_1.Genre.Josei] = enum_1.Genre.Josei;
Supported[enum_1.Genre.Lolicon] = enum_1.Genre.Lolicon;
Supported[enum_1.Genre.MartialArts] = enum_1.Genre.MartialArts;
Supported[enum_1.Genre.Mature] = enum_1.Genre.Mature;
Supported[enum_1.Genre.Mecha] = enum_1.Genre.Mecha;
Supported[enum_1.Genre.Mystery] = enum_1.Genre.Mystery;
Supported[enum_1.Genre.Oneshot] = enum_1.Genre.Oneshot;
Supported[enum_1.Genre.Psychological] = enum_1.Genre.Psychological;
Supported[enum_1.Genre.Romance] = enum_1.Genre.Romance;
Supported[enum_1.Genre.SchoolLife] = enum_1.Genre.SchoolLife;
Supported[enum_1.Genre.SciFi] = enum_1.Genre.SciFi;
Supported[enum_1.Genre.Seinen] = enum_1.Genre.Seinen;
Supported[enum_1.Genre.Shotacon] = enum_1.Genre.Shotacon;
Supported[enum_1.Genre.Shoujo] = enum_1.Genre.Shoujo;
Supported[enum_1.Genre.ShoujoAi] = enum_1.Genre.ShoujoAi;
Supported[enum_1.Genre.Shounen] = enum_1.Genre.Shounen;
Supported[enum_1.Genre.ShounenAi] = enum_1.Genre.ShounenAi;
Supported[enum_1.Genre.SliceOfLife] = enum_1.Genre.SliceOfLife;
Supported[enum_1.Genre.Smut] = enum_1.Genre.Smut;
Supported[enum_1.Genre.Sports] = enum_1.Genre.Sports;
Supported[enum_1.Genre.Supernatural] = enum_1.Genre.Supernatural;
Supported[enum_1.Genre.Tragedy] = enum_1.Genre.Tragedy;
Supported[enum_1.Genre.Yaoi] = enum_1.Genre.Yaoi;
Supported[enum_1.Genre.Yuri] = enum_1.Genre.Yuri;
var correctName = {};
correctName[enum_1.Genre.Adult] = enum_1.Genre.Adult;
correctName[enum_1.Genre.Action] = enum_1.Genre.Action;
correctName[enum_1.Genre.Adventure] = enum_1.Genre.Adventure;
correctName[enum_1.Genre.Comedy] = enum_1.Genre.Comedy;
correctName[enum_1.Genre.Doujinshi] = enum_1.Genre.Doujinshi;
correctName[enum_1.Genre.Drama] = enum_1.Genre.Drama;
correctName[enum_1.Genre.Ecchi] = enum_1.Genre.Ecchi;
correctName[enum_1.Genre.Fantasy] = enum_1.Genre.Fantasy;
correctName[enum_1.Genre.GenderBender] = "Gender Bender";
correctName[enum_1.Genre.Harem] = enum_1.Genre.Harem;
correctName[enum_1.Genre.Historical] = enum_1.Genre.Historical;
correctName[enum_1.Genre.Horror] = enum_1.Genre.Horror;
correctName[enum_1.Genre.Josei] = enum_1.Genre.Josei;
correctName[enum_1.Genre.Lolicon] = enum_1.Genre.Lolicon;
correctName[enum_1.Genre.MartialArts] = "Martial Arts";
correctName[enum_1.Genre.Mature] = enum_1.Genre.Mature;
correctName[enum_1.Genre.Mecha] = enum_1.Genre.Mecha;
correctName[enum_1.Genre.Mystery] = enum_1.Genre.Mystery;
correctName[enum_1.Genre.Oneshot] = "One Shot";
correctName[enum_1.Genre.Psychological] = enum_1.Genre.Psychological;
correctName[enum_1.Genre.Romance] = enum_1.Genre.Romance;
correctName[enum_1.Genre.SchoolLife] = enum_1.Genre.SchoolLife;
correctName[enum_1.Genre.SciFi] = "Sci-fi";
correctName[enum_1.Genre.Seinen] = enum_1.Genre.Seinen;
correctName[enum_1.Genre.Shotacon] = enum_1.Genre.Shotacon;
correctName[enum_1.Genre.Shoujo] = enum_1.Genre.Shoujo;
correctName[enum_1.Genre.ShoujoAi] = "Shoujo Ai";
correctName[enum_1.Genre.Shounen] = enum_1.Genre.Shounen;
correctName[enum_1.Genre.ShounenAi] = "Shounen Ai";
correctName[enum_1.Genre.SliceOfLife] = "Slice of Life";
correctName[enum_1.Genre.Smut] = enum_1.Genre.Smut;
correctName[enum_1.Genre.Sports] = enum_1.Genre.Sports;
correctName[enum_1.Genre.Supernatural] = enum_1.Genre.Supernatural;
correctName[enum_1.Genre.Tragedy] = enum_1.Genre.Tragedy;
correctName[enum_1.Genre.Yaoi] = enum_1.Genre.Yaoi;
correctName[enum_1.Genre.Yuri] = enum_1.Genre.Yuri;
exports.processFilter = function (mangafilter) {
    var filter = util_1.procFilter(mangafilter);
    var search = filter.search, page = filter.page;
    var filterType = null;
    var filterName = filter.search.name;
    var filterAuthor = null;
    var filterArtist = null;
    var filterReleased = null;
    var status = null;
    var methodName = "cw";
    var methodAuthor = "cw";
    var methodArtist = "cw";
    var methodReleased = "eq";
    var inGenres = [];
    var outGenres = [];
    if (search) {
        var name = search.name, author_1 = search.author, artist_1 = search.artist, rating = search.rating, released = search.released, type_1 = search.type, genre = search.genre;
        filterType = resolveType(type_1) || filterType;
        if (name) {
            // filterName = name.name || filterName;
            methodName = searchMethod(name.condition) || methodName;
        }
        if (search.status) {
            status = resolveStatus(search.status) || status;
        }
        if (author_1) {
            filterAuthor = author_1.name || filterAuthor;
            methodAuthor = searchMethod(author_1.condition) || methodAuthor;
        }
        if (artist_1) {
            filterArtist = artist_1.name || filterArtist;
            methodArtist = searchMethod(artist_1.condition) || methodArtist;
        }
        if (released) {
            filterReleased = released.value || filterReleased;
            methodReleased = searchMethod(released.condition) || methodReleased;
        }
        if (genre) {
            inGenres = genre.inGenres;
            outGenres = genre.outGenres;
        }
    }
    var type = "direction=" + (filterType || "");
    var nameMethod = "name_method=" + methodName; // NOTE name search set to contains
    var mangaName = "name=" + (filterName || "");
    var authorMethod = "author_method=" + methodAuthor;
    var author = "author=" + (filterAuthor || "");
    var artistMethod = "artist_method=" + methodArtist;
    var artist = "artist=" + (filterArtist || "");
    var genreFilter = lodash_1.map(Supported, function (x) { return "genres%5B" + correctName[x].replace(/ /g, "+") + "%5D=" + inOutGenre(x, inGenres, outGenres); }).join("&");
    var releaseMethod = "released_method=" + methodReleased;
    var release = "released=" + (filterReleased || "");
    var completed = "is_completed=" + (status || "");
    var advopts = "advopts=1"; // NOTE not sure what is this
    if (page) {
        advopts += "&page=" + page;
    }
    return {
        src: url_1.resolve(config_1.config.site, "/search.php?" + [nameMethod, mangaName,
            type,
            authorMethod, author,
            artistMethod, artist,
            genreFilter,
            releaseMethod, release,
            completed, advopts].join("&"))
    };
};
function resolveType(type) {
    switch (type) {
        case enum_1.Type.Manga:
            return "rl";
        case enum_1.Type.Manhwa:
            return "lr";
        default:
            return null;
    }
}
function resolveStatus(status) {
    switch (status) {
        case enum_1.FilterStatus.Ongoing:
            return 0;
        case enum_1.FilterStatus.Complete:
            return 1;
        default:
            return null;
    }
}
function searchMethod(condition) {
    switch (condition) {
        case enum_1.FilterCondition.Contains:
            return "cw";
        case enum_1.FilterCondition.StartsWith:
            return "bw";
        case enum_1.FilterCondition.EndsWith:
            return "ew";
        case enum_1.FilterCondition.Equal:
            return "eq";
        case enum_1.FilterCondition.LessThan:
            return "lt";
        case enum_1.FilterCondition.GreaterThan:
            return "gt";
        default:
            return "cw";
    }
}
function inOutGenre(genre, inGenre, outGenre) {
    if (inGenre && inGenre.indexOf(genre) > -1) {
        return 1;
    }
    if (outGenre && outGenre.indexOf(genre) > -1) {
        return 2;
    }
    return 0;
}
