"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var cheerio = require("cheerio");
var enum_1 = require("./enum");
var regexLastDigit = /\d+(\.\d{1,3})?$/;
var regexFirstDigit = /\d+(\.\d{1,3})?/;
String.prototype.lastDigit = function () {
    var match = this.match(regexLastDigit);
    if (!match) {
        return null;
    }
    return +match[0];
};
String.prototype.firstDigit = function () {
    var match = this.match(regexFirstDigit);
    if (!match) {
        return null;
    }
    return +match[0];
};
String.prototype.leftTrim = function () {
    return this.replace(/^\s+/, "");
};
String.prototype.decodeEscapeSequence = function () {
    return this.replace(/\\x([0-9A-Fa-f]{2})/g, function () {
        return String.fromCharCode(parseInt(arguments[1], 16));
    });
};
function promiseSetTimeout(ms) {
    return new Promise((function (resolve) { return setTimeout(resolve, ms); }));
}
exports.promiseSetTimeout = promiseSetTimeout;
function promiseSetTimeoutWithPromise(ms, p) {
    return promiseSetTimeout(ms)
        .then(function (x) { return p; });
}
exports.promiseSetTimeoutWithPromise = promiseSetTimeoutWithPromise;
var Lazy = (function () {
    function Lazy(_func) {
        this._func = _func;
    }
    Object.defineProperty(Lazy.prototype, "value", {
        get: function () {
            return this._value || (this._value = this._func());
        },
        enumerable: true,
        configurable: true
    });
    return Lazy;
}());
exports.Lazy = Lazy;
exports.parseDoc = function (source, params) {
    if (params === void 0) { params = undefined; }
    var doc = cheerio.load(source);
    doc.location = params && params.location;
    return doc;
};
exports.sanitize = function (children) { return children.filter(function (x) { return x.type !== "text"; }); };
exports.sanitizeName = function (name) {
    return name; // not sure if we should use this
    // const regex = /(?:’|–|Ζ|∞|[\u00b0-\u00bf]|[\u2700-\u27bf]|(?:\ud83c[\udde6-\uddff]){2}|[\ud800-\udbff][\udc00-\udfff]|[\u0023-\u0039]\ufe0f?\u20e3|\u3299|\u3297|\u303d|\u3030|\u24c2|\ud83c[\udd70-\udd71]|\ud83c[\udd7e-\udd7f]|\ud83c\udd8e|\ud83c[\udd91-\udd9a]|\ud83c[\udde6-\uddff]|[\ud83c[\ude01-\ude02]|\ud83c\ude1a|\ud83c\ude2f|[\ud83c[\ude32-\ude3a]|[\ud83c[\ude50-\ude51]|\u203c|\u2049|[\u25aa-\u25ab]|\u25b6|\u25c0|[\u25fb-\u25fe]|\u00a9|\u00ae|\u2122|\u2139|\ud83c\udc04|[\u2600-\u26FF]|\u2b05|\u2b06|\u2b07|\u2b1b|\u2b1c|\u2b50|\u2b55|\u231a|\u231b|\u2328|\u23cf|[\u23e9-\u23f3]|[\u23f8-\u23fa]|\ud83c\udccf|\u2934|\u2935|[\u2190-\u21ff])/g;
    //
    // return name.replace(regex, encodeURIComponent);
};
exports.procFilter = function (condition, def) {
    var search = (def && def.search) || {};
    if (typeof condition === "string") {
        search.name = {
            name: condition
        };
        return { search: search };
    }
    else {
        var nc = (condition && condition.name && { name: condition.name }) || undefined;
        var ns = (condition && condition.search) || undefined;
        search = __assign({ name: nc }, search, ns);
        if (search) {
            var genre = search.genre, name = search.name, author = search.author, artist = search.artist, released = search.released, rating = search.rating;
            if (Array.isArray(genre)) {
                var inGenres = genre;
                search.genre = {
                    inGenres: inGenres,
                    condition: enum_1.GenreCondition.And,
                };
            }
            if (typeof name === "string") {
                search.name = {
                    name: name
                };
            }
            if (typeof author === "string") {
                search.author = {
                    name: author
                };
            }
            if (typeof artist === "string") {
                search.artist = {
                    name: artist
                };
            }
            if (typeof released === "number") {
                search.released = {
                    value: released
                };
            }
            if (typeof rating === "number") {
                search.rating = {
                    from: rating
                };
            }
        }
    }
    //
    // if (filter.name) {
    //   filter.name = sanitizeName(filter.name);
    // }
    // if (filter.search && filter.search.name) {
    //   const name = filter.search.name;
    //
    //   if (typeof name !== "string") {
    //     name.name = sanitizeName(name.name);
    //   }
    // }
    return __assign({}, condition, { search: search });
};
/*NOTE not sure*/
function getLocationByCharacters(str) {
}
exports.getLocationByCharacters = getLocationByCharacters;
function containsChineseCharacters(x) {
}
exports.containsChineseCharacters = containsChineseCharacters;
function containsJapaneseCharacters(x) {
    return !!x.match(jpRegex);
}
exports.containsJapaneseCharacters = containsJapaneseCharacters;
var jpRegex = /[\u3000-\u303F]|[\u3040-\u309F]|[\u30A0-\u30FF]|[\uFF00-\uFFEF]|[\u4E00-\u9FAF]|[\u2605-\u2606]|[\u2190-\u2195]|\u203B/g;
/*ending*/
